## Configuration

_See full configuration [here](https://github.com/Hydrospheredata/mist/blob/master/src/main/resources/master.conf)_

Configuration files are in [HOCON format](https://github.com/typesafehub/config/blob/master/HOCON.md)

| Property name                         | Default value         | Meaning                                                                                                                                                                                                                                                                                                                                                                                |
|---------------------------------------|-----------------------|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| `mist.http.on`                        | false                 | Turning HTTP server on/off                                                                                                                                                                                                                                                                                                                                                             |
| `mist.http.host`                      | 0.0.0.0               | Listening host for HTTP server                                                                                                                                                                                                                                                                                                                                                      |
| `mist.http.port`                      | 2003                  | Listening port for HTTP server                                                                                                                                                                                                                                                                                                                                                      |
|                                       |                       |                                                                                                                                                                                                                                                                                                                                                                                        |
| `mist.mqtt.on`                        | false                 | Turning on/off support of async jobs with [MQTT](http://mqtt.org/)                                                                                                                                                                                                                                                                                                                     |
| `mist.mqtt.host`                      | localhost             | MQTT server host                                                                                                                                                                                                                                                                                                                                                                       |
| `mist.mqtt.port`                      | 1883                  | MQTT server port                                                                                                                                                                                                                                                                                                                                                                       |
| `mist.mqtt.subscribe-topic`           | _no default value_    | Topic Mist listens to for incoming requests                                                                                                                                                                                                                                                                                                                                          |
| `mist.mqtt.publish-topic`             | _no default value_    | Topic Mist writes response into                                                                                                                                                                                                                                                                                                                                          |
|                                       |                       |                                                                                                                                                                                                                                                                                                                                                                                        |
| `mist.context-defaults`               |                       | Default meta-setting for each running [namespace](context-namespaces.md)                                                                                                                                                                                                                                                                                                               |
| `mist.context.<namespace>`            |                       | [Namespace](context-namespaces.md)-specific settings                                                                                                                                                                                                                                                                                                                                   |
|                                       |                       |                                                                                                                                                                                                                                                                                                                             |
| `mist.context.<namespace>.downtime`    | Inf                   | Downtime worker's before stopping                                                                                                                                                                                                                                                                                                 |
|                                       |                       |                                                                                                                                                                                                                                                                                                                                                                                  |
| `mist.context.<namespace>.spark-conf` | _no default value_    | Spark settings for context in `<namespace>` for example: <br><code>mist.context-defaults.spark-conf = {</code><br><code>&nbsp;&nbsp;&nbsp;&nbsp;spark.master&nbsp;&nbsp;=&nbsp;local[*]</code><br><code>&nbsp;&nbsp;&nbsp;&nbsp;spark.default.parallelism&nbsp;&nbsp;=&nbsp;128</code><br><code>&nbsp;&nbsp;&nbsp;&nbsp;spark.driver.memory&nbsp;=&nbsp;"10g"</code><br><code>&nbsp;&nbsp;&nbsp;&nbsp;spark.scheduler.mode&nbsp;=&nbsp;"FAIR"</code><br><code>}</code> |
| `mist.context.<namespace>.streaming-duration` | 1 second      | Spark Streaming Duration in `<namespace>`                                                                                                                                                                                                                                                                                                                                                                               |
| `mist.context.<namespace>.worker-mode` | shared | Run mode for worker in `<namespace>` should be `shared` or `exclusive`                                                                                                                                                                                                                                                                                                                                                                              |

### Enable Kerberos

Example:

```hocon
mist {
  security {
    enabled = true
    keytab = ${path_to_keytab}
    principal = ${your_principal}
    interval = 30 minutes # default 1 hour
  }
}
```
